package com.ruoyi.benyun.controller;

import com.ruoyi.benyun.entity.vo.TopologicalWdAceeptVo;
import com.ruoyi.benyun.service.TopologicalBuildWdSerevice;
import com.ruoyi.benyun.valida.TopologicalWdListGroup;
import com.ruoyi.benyun.constant.RedisContant;
import com.ruoyi.benyun.entity.TopologicalBuildingWd;
import com.ruoyi.benyun.entity.bo.BuildWdCategoryCount;
import com.ruoyi.common.core.domain.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.concurrent.TimeUnit;

@RestController
@RequestMapping("/poi/topologicalBuildWd")
public class TopologicalBuildWdController {
    @Autowired
    TopologicalBuildWdSerevice topologicalBuildWdSerevice;

    @Autowired
    RedisTemplate redisTemplate;

    @RequestMapping("/buildingLevel")
    public R buildingLevel(@Validated(value = {TopologicalWdListGroup.class}) TopologicalWdAceeptVo topologicalWdAceeptVo){
        String md5 = topologicalWdAceeptVo.getHash();
        //2.查看redis中是否存在有缓存
        List<BuildWdCategoryCount> wdCount = (List<BuildWdCategoryCount>) redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_BUILD_WD_CATEGORY).get(md5);
        if (wdCount != null) {
            return R.ok(wdCount);
        }

        List<BuildWdCategoryCount> list = topologicalBuildWdSerevice.buildingLevel(topologicalWdAceeptVo);

        redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_BUILD_WD_CATEGORY).put(md5,list);
        redisTemplate.expire(RedisContant.TOPOLOGICAL_BUILD_WD_CATEGORY,RedisContant.TOPOLOGICAL_BUILD_WD_CATEGORY_TIME, TimeUnit.MINUTES); //30分钟

        return R.ok(list);
    }

    @RequestMapping("/list")
    public R list(@Validated(value = {TopologicalWdListGroup.class}) TopologicalWdAceeptVo topologicalWdAceeptVo){
        String md5 = topologicalWdAceeptVo.getHash();
        //2.查看redis中是否存在有缓存
        List<TopologicalBuildingWd> wdCount = (List<TopologicalBuildingWd>)redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_BUILD_WD_LIST).get(md5);
        if (wdCount != null) {
            return R.ok(wdCount);
        }

        List<TopologicalBuildingWd> list = topologicalBuildWdSerevice.list(topologicalWdAceeptVo);

        redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_BUILD_WD_LIST).put(md5,list);
        redisTemplate.expire(RedisContant.TOPOLOGICAL_BUILD_WD_LIST,RedisContant.TOPOLOGICAL_BUILD_WD_LIST_TIME, TimeUnit.MINUTES); //30分钟

        return R.ok(list);
    }
}
