package com.ruoyi.demo.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.demo.service.CategoryService;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@Validated
@RequiredArgsConstructor
@RestController
public class CategoryCotroller {
    @Autowired
    CategoryService categoryService;

    /**
     * 获取地区信息
     *
     * @return
     */
    @GetMapping("/getAddrCategory")
    public R getAddrCategory(){
        return R.ok(categoryService.getAddrCategory());
    }

    /**
     * 获取经营分类
     *
     * @return
     */
    @GetMapping("/getManageCategory")
    public R getManageCategory(){
        return R.ok(categoryService.getManageCategory());
    }

    /**
     * 获取网点分类（犇云）
     *
     * @return
     */
    @GetMapping("/getTypeByCategory")
    public R getTypeByCategoryTest(){
        return R.ok(categoryService.getTypeByCategory());
    }

    /**
     * 获取网点类型
     *
     * @return
     */
    @GetMapping("/getWdTypeCategory")
    public R getWdTypeCategory(){
        return R.ok(categoryService.getWdTypeCategory());
    }
}
