package com.ruoyi.demo.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.demo.entity.Enterprise;
import com.ruoyi.demo.entity.vo.EnterpriseVo;
import com.ruoyi.demo.service.EnterpriseRecycleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.validation.constraints.NotBlank;
import java.util.HashMap;

@RestController
@RequestMapping("/recycle/enterprise")
public class EnterpriseRecycleController {
    @Autowired
    EnterpriseRecycleService enterpriseRecycleService;

    @GetMapping("/list")
    public R list(EnterpriseVo enterpriseVo){
        Page<Enterprise> list = enterpriseRecycleService.list(enterpriseVo);
        return R.ok(list);
    }

    @PostMapping("/addEnterprise")
    public R addEnterprise(@Validated(value = {AddGroup.class}) @RequestBody EnterpriseVo enterpriseVo){
        String s = enterpriseRecycleService.addEnterprise(enterpriseVo);
        return R.ok(s);
    }

    @DeleteMapping("/deleteEnterprise/{enterpriseUsci}")
    public R deleteEnterprise(@PathVariable(name = "enterpriseUsci") @NotBlank(message = "enterpriseUsci不能为空") String enterpriseUsci){
        enterpriseRecycleService.deleteEnterprise(enterpriseUsci);
        return R.ok();
    }

    @PutMapping("/updateEnterprise")
    public R updateEnterprise(@Validated(value = {EditGroup.class}) @RequestBody EnterpriseVo enterpriseVo){
        enterpriseRecycleService.updateEnterprise(enterpriseVo);
        return R.ok();
    }

    /**
     * 恢复企业
     * @param hashMap
     * @return
     */
    @PutMapping("/recoverEnterprise")
    public R recoverEnterprise(@RequestBody HashMap<String,String> hashMap){
        if(hashMap.get("enterpriseUsci") == null)
            return R.fail(400,"enterpriseUsci不能为空");

        enterpriseRecycleService.recoverEnterprise(hashMap.get("enterpriseUsci"));
        return R.ok();
    }

    @GetMapping("/getEnterprise")
    public R getEnterprise(String enterpriseUsci){
        Enterprise enterprise = enterpriseRecycleService.getEnterprise(enterpriseUsci);
        return R.ok(enterprise);
    }

}
