package com.ruoyi.demo.entity;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import com.ruoyi.demo.entity.vo.TurnBusinessOpportunitiesVo;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.UUID;

@Data
@TableName("bl_business_opportunities_clue")
public class BusinessOpportunitiesClue implements Serializable {
    @TableField("clue_id")
    private String clueId;

    @TableField("attention_id")
    private String attentionId;

    @TableField("wd_id")
    private String wdId;

    @TableField("wd_name")
    private String wdName;

    @TableField("wd_addr_info")
    private String wdAddrInfo;

    @TableField("brand_id")
    private String brandId;

    @TableField("brand_name")
    private String brandName;

    @TableField("contact")
    private String contact;

    @TableField("telephone")
    private String telephone;

    @TableField("follow_up_count")
    private Integer followUpCount;

    @TableField("user_id")
    private String userId;

    @TableField("create_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    public BusinessOpportunitiesClue() {
    }

    public BusinessOpportunitiesClue(TurnBusinessOpportunitiesVo vo, AttentionPool pool, String userId) {
        this.clueId = UUID.randomUUID().toString().replace("-", "");
        this.attentionId = vo.getAttentionId();
        this.wdId = pool.getWdId();
        this.wdName = pool.getWdName();
        this.wdAddrInfo = pool.getWdAddrInfo();
        this.brandId = pool.getBrandId();
        this.brandName = pool.getBrandName();
        this.contact = vo.getContact();
        this.telephone = vo.getTelephone();
        this.followUpCount = 0;
        this.userId = userId;
        this.createTime = DateUtil.date();
    }
}
