package com.ruoyi.demo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;

/**
 * 门店网点
 */
@Data
@TableName("ddt_store_wd")
public class StoreWd implements Serializable {
    /**
     * 网点基本信息_id（外键）
     */
    @TableId("wd_id")
    private String wdId;
    /**
     * 品牌_id（外键）
     */
    @TableField("brand_id")
    private String brandId;
    /**
     * 品牌名字
     */
    @TableField("brand_name")
    private String brandName;
    /**
     * 人均消费
     */
    @TableField("per_capita_consumption")
    private Double perCapitaConsumption;
    /**
     * 经营类别
     */
    @TableField("manage_type_code")
    private String manageTypeCode;
    /**
     * 行业分类（关联行业分类表）
     */
    @TableField("industry_code")
    private String industryCode;
    /**
     * 门店规模（连锁）
     */
    @TableField("organization_code")
    private String organizationCode;
    /**
     * 网点评论数
     */
    @TableField("comment_count")
    private int commentCount;
    /**
     * 网点评分
     */
    @TableField("score")
    private Double score;
    /**
     * 网点团购信息
     */
    @TableField("buy_info")
    private String buyInfo;
    /**
     * 旺店指数
     */
    @TableField("index_score")
    private double indexScore;
    /**
     * 营业状态（正常、暂停、尚未营业）
     */
    @TableField("business_status")
    private String businessStatus;
    /**
     * 营业时间
     */
    @TableField("business_time")
    private String businessTime;
    /**
     * 联系电话
     */
    @TableField("telephone")
    private String telephone;
    /**
     * 联系人
     */
    @TableField("contact")
    private String contact;
    /**
     * 渠道商类型
     */
    @TableField("channel_type")
    private String channelType;
    /**
     * 开店时间
     */
    @TableField("opentime")
    private String opentime;
    /**
     * 关店时间
     */
    @TableField("closetime")
    private String closetime;
}
