package com.ruoyi.demo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * 周边楼宇网点结果实体类
 */
@Data
@TableName("bl_topological_building_wd_list")
public class TopologicalBuildingWd implements Serializable {

    /**
     * 周边网点Id
     */
    private String aroundWdId;
    /**
     * 周边网点名称
     */
    private String aroundWdName;
    /**
     * 周边网点类型
     */
    private String aroundWdTypeCode;
    /**
     * 距离
     */
    private double distance;
    /**
     * 地区Code
     */
    private String addrCode;
    /**
     * 地区信息
     */
    private String addrCodeInfo;
    /**
     * 地址信息
     */
    private String addrInfo;
    /**
     * 租金
     */
    private double rent;
    /**
     * 楼宇类型
     */
    private String buildType;
    /**
     * 物业类型
     */
    private String propertyType;
    /**
     * 纬度
     */
    private double lat;
    /**
     * 经度
     */
    private double lng;

    public TopologicalBuildingWd(WdInfo wdInfo) {
        this.aroundWdId = wdInfo.getWdId();
        this.aroundWdName = wdInfo.getWdName();
        this.aroundWdTypeCode = wdInfo.getWdTypeCode();
        this.addrCode = wdInfo.getAddrCode();
        this.addrInfo = wdInfo.getAddrInfo();
        this.lat = wdInfo.getLat().doubleValue();
        this.lng = wdInfo.getLng().doubleValue();
    }

    public TopologicalBuildingWd() {
    }
}
