package com.ruoyi.demo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * 周边企业网点结果实体类
 */
@Data
@TableName("bl_topological_enterprise_wd_list")
public class TopologicalEnterpriseWd implements Serializable {
    /**
     * 周边网点Id
     */
    @TableField("around_wd_id")
    private String aroundWdId;
    /**
     * 周边网点名称
     */
    @TableField("around_wd_name")
    private String aroundWdName;
    /**
     * 周边网点类型
     */
    @TableField("around_wd_type_code")
    private String aroundWdTypeCode;
    /**
     * 距离
     */
    @TableField("distance")
    private double distance;
    /**
     * 地区Code
     */
    @TableField("addr_code")
    private String addrCode;
    /**
     * 地区信息
     */
    @TableField("addr_code_info")
    private String addrCodeInfo;
    /**
     * 地址
     */
    @TableField("addr_info")
    private String addrInfo;
    /**
     * 行业Code
     */
    @TableField("industry_code")
    private String industryCode;
    /**
     * 注册资本
     */
    @TableField("registered_capital")
    private BigDecimal registeredCapital;
    /**
     * 企业规模
     */
    @TableField("enterprise_scale")
    private String enterpriseScale;
    /**
     * 纬度
     */
    private double lat;
    /**
     * 经度
     */
    private double lng;

    public TopologicalEnterpriseWd(WdInfo wdInfo) {
        this.aroundWdId = wdInfo.getWdId();
        this.aroundWdName = wdInfo.getWdName();
        this.aroundWdTypeCode = wdInfo.getWdTypeCode();
        this.addrCode = wdInfo.getAddrCode();
        this.addrInfo = wdInfo.getAddrInfo();
        this.lat = wdInfo.getLat().doubleValue();
        this.lng = wdInfo.getLng().doubleValue();
    }

    public TopologicalEnterpriseWd() {
    }
}
