package com.ruoyi.demo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 周边小区网点结果实体类
 */
@Data
@TableName("bl_topological_house_wd_list")
public class TopologicalHouseWd implements Serializable {
    /**
     * 周边网点Id
     */
    public String aroundWdId;
    /**
     * 网点名称
     */
    public String aroundWdName;
    /**
     * 网点类型Code
     */
    public String aroundWdTypeCode;
    /**
     * 距离
     */
    public double distance;
    /**
     * 地区Code
     */
    public String addrCode;
    /**
     * 地区信息
     */
    public String addrCodeInfo;
    /**
     * 地址信息
     */
    public String addrInfo;
    /**
     * 租金
     */
    public double rent;
    /**
     * 物业类型
     */
    public String propertyType;
    /**
     * 户数
     */
    public int households;
    /**
     * 人口数量
     */
    public int peopleCount;
    /**
     * 纬度
     */
    private double lat;
    /**
     * 经度
     */
    private double lng;

    public TopologicalHouseWd(WdInfo wdInfo) {
        this.aroundWdId = wdInfo.getWdId();
        this.aroundWdName = wdInfo.getWdName();
        this.aroundWdTypeCode = wdInfo.getWdTypeCode();
        this.addrCode = wdInfo.getAddrCode();
        this.addrInfo = wdInfo.getAddrInfo();
        this.lat = wdInfo.getLat().doubleValue();
        this.lng = wdInfo.getLng().doubleValue();
    }

    public TopologicalHouseWd() {

    }
}
