package com.ruoyi.demo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 周边门店网点结果实体类
 */
@Data
public class TopologicalStoreWd implements Serializable {
    /**
     * 周边网点Id
     */
    private String aroundWdId;
    /**
     * 周边网点名称
     */
    private String aroundWdName;
    /**
     * 周边网点类型Code
     */
    private String aroundWdTypeCode;
    /**
     * 距离
     */
    private double distance;
    /**
     * 地区Code
     */
    private String addrCode;
    /**
     * 地区信息
     */
    private String addrCodeInfo;
    /**
     * 地址信息
     */
    private String addrInfo;
    /**
     * 经度
     */
    private double lng;
    /**
     * 纬度
     */
    private double lat;

    public TopologicalStoreWd(WdInfo wdInfo) {
        this.aroundWdId = wdInfo.getWdId();
        this.aroundWdName = wdInfo.getWdName();
        this.aroundWdTypeCode = wdInfo.getWdTypeCode();
        this.addrCode = wdInfo.getAddrCode();
        this.addrInfo = wdInfo.getAddrInfo();
        this.lng = wdInfo.getLng().doubleValue();
        this.lat = wdInfo.getLat().doubleValue();
    }

    public TopologicalStoreWd() {
    }
}
