package com.ruoyi.demo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateDeserializer;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateSerializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * 网点基本信息
 */
@Data
@TableName("ddt_wd_info")
public class WdInfo implements Serializable {
    /**
     * 网点Id
     */
    @TableId("wd_id")
    private String wdId;
    /**
     * 图片
     */
    @TableField("wd_img")
    private String wdImg;
    /**
     * 网点名称
     */
    @TableField("wd_name")
    private String wdName;
    /**
     * 成立时间
     */
    @TableField("create_date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date createDate;
    /**
     * 地址信息
     */
    @TableField("addr_info")
    private String addrInfo;
    /**
     * 地区信息（关联地区表）
     */
    @TableField("addr_code")
    private String addrCode;
    /**
     * 纬度
     */
    @TableField("lat")
    private BigDecimal lat;
    /**
     * 经度
     */
    @TableField("lng")
    private BigDecimal lng;
    /**
     * 网点所属分类_腾讯
     */
    @TableField("type_code_tx")
    private String typeCodeTx;
    /**
     * 分类名字_腾讯
     */
    @TableField("type_name_tx")
    private String typeNameTx;
    /**
     * 网点所属分类_高德
     */
    @TableField("type_code_gd")
    private String typeCodeGd;
    /**
     * 分类名字_高德
     */
    @TableField("type_name_gd")
    private String typeNameGd;
    /**
     * 网点所属分类_犇云
     */
    @TableField("type_code_by")
    private String typeCodeBy;
    /**
     * 分类名字_犇云
     */
    @TableField("type_name_by")
    private String typeNameBy;
    /**
     * 房租水平
     */
    @TableField("rent")
    private Double rent;
    /**
     * 验证状态
     */
    @TableField("audit")
    private int audit;
    /**
     * 网点类型
     */
    @TableField("wd_type_code")
    private String wdTypeCode;
    /**
     * 入库时间
     */
    @TableField("enter_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date enterTime;
    /**
     * 最近更新时间
     */
    @TableField("update_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
    /**
     * 采集人用户id
     */
    @TableField("collect_user_id")
    private String collectUserId;
    /**
     * 采集人
     */
    @TableField("collect_person")
    private String collectPerson;
    /**
     * 采集时间
     */
    @TableField("collect_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date collectTime;
    /**
     * 查重Hash
     */
    @TableField("hash")
    private String hash;
    /**
     * geoHash编码
     */
    @TableField("geo_hash")
    private String geoHash;
    /**
     * 逻辑删除
     */
    @TableField("show_delete")
    @TableLogic
    private int showDelete;

    /**
     * 是否关注
     */
    @TableField(exist = false)
    private int attention;
}
