package com.ruoyi.demo.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.demo.utils.HashUtil;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class EnterpriseVo {
    /**
     * 统一社会信用代码
     */
    @NotBlank(message = "enterpriseUsci不能为空",groups = {AddGroup.class, EditGroup.class})
    private String enterpriseUsci;
    /**
     * 企业图片
     */
    private String enterpriseImg;
    /**
     * 企业名称
     */
    @NotBlank(message = "enterpriseName不能为空",groups = {AddGroup.class, EditGroup.class})
    private String enterpriseName;
    /**
     * 企业简称
     */
    private String enterpriseNameShort;
    /**
     * 地址信息
     */
    @NotBlank(message = "地址信息不能为空",groups = {AddGroup.class, EditGroup.class})
    private String addrInfo;
    /**
     * 地区Code
     */
    @NotBlank(message = "地区Code不能为空",groups = {AddGroup.class, EditGroup.class})
    private String addrCode;
    /**
     * 地区信息
     */
    @NotBlank(message = "地区信息不能为空",groups = {AddGroup.class, EditGroup.class})
    private String addrCodeInfo;
    /**
     * 公司简介
     */
    private String enterpriseInfo;
    /**
     * 经营范围描述
     */
    private String manageRangeInfo;
    /**
     * 企业规模
     */
    private String enterpriseScale;
    /**
     * 注册资本
     */
    private String registeredCapital;
    /**
     * 企业法人_id
     */
    private String linkmenId;
    /**
     * 法定代表人名字
     */
    private String linkmenName;
    /**
     * 成立日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
    /**
     * 纳税人识别号
     */
    @NotBlank(message = "纳税人识别号不能为空",groups = {AddGroup.class, EditGroup.class})
    private String enterpriseItin;
    /**
     * 经营状态：存续、在业、吊销、注销、迁入、迁出、停业、清算
     */
    @NotBlank(message = "经营状态不能为空",groups = {AddGroup.class, EditGroup.class})
    private String businessStatus;
    /**
     * 行业分类（关联行业分类表）
     */
    private String industryCode;
    /**
     * 企业类型：有限责任公司; 股份公司；股份有限公司
     */
    @NotBlank(message = "企业类型不能为空",groups = {AddGroup.class, EditGroup.class})
    private String enterpriseType;
    /**
     * 信用评分
     */
    private int creditScore;
    /**
     * 验证状态
     */
    private int audit;
    /**
     * 采集人用户id
     */
    private String collectUserId;
    /**
     * 采集人
     */
    private String collectPerson;
    /**
     * 采集时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date collectTime;
    /**
     * 入库时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date enterTime;
    /**
     * 最近更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
    /**
     * Hash
     */
    private String hash;
    private Integer showDelete;
    int pageNum = 1;

    int pageSize = 10;

    public String getHash(){
        String s = enterpriseUsci+enterpriseName+enterpriseItin+enterpriseScale;
        return HashUtil.hash(s,"MD5");
    }
}
