package com.ruoyi.demo.entity.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.demo.entity.WdInfo;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class WdInfoVo implements Serializable {
    @NotBlank(message = "网点Id不能为空",groups = {EditGroup.class})
    private String wdId;
    @NotBlank(message = "网点名称不能为空",groups = {EditGroup.class})
    private String wdName;
    @NotBlank(message = "地址信息不能为空",groups = {EditGroup.class})
    private String addrInfo;
    @NotBlank(message = "地区Code不能为空",groups = {EditGroup.class})
    private String addrCode;
//    @NotBlank(message = "地址信息不能为空",groups = {EditGroup.class})
//    private String addrCodeInfo;
    @NotNull(message = "纬度不能为空",groups = {EditGroup.class})
    private BigDecimal lat;
    @NotNull(message = "经度不能为空",groups = {EditGroup.class})
    private BigDecimal lng;
    private String typeCodeBy;
    private String typeNameBy;
    private String wdTypeCode;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date enterTime;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
    private String collectUserId;
    private String collectPerson;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date collectTime;

    @TableField("show_delete")
    private int showDelete = -1;

    int pageNum = 1;

    int pageSize = 10;

    private String orderBy = "collect_time";

    public WdInfoVo(WdInfo wdInfo) {
        this.wdId = wdInfo.getWdId();
        this.wdName = wdInfo.getWdName();
        this.addrInfo = wdInfo.getAddrInfo();
        this.addrCode = wdInfo.getAddrCode();
        this.lat = wdInfo.getLat();
        this.lng = wdInfo.getLng();
        this.typeCodeBy = wdInfo.getTypeCodeBy();
        this.typeNameBy = wdInfo.getTypeNameBy();
        this.wdTypeCode = wdInfo.getWdTypeCode();
        this.enterTime = wdInfo.getEnterTime();
        this.updateTime = wdInfo.getUpdateTime();
        this.collectUserId = wdInfo.getCollectUserId();
        this.collectPerson = wdInfo.getCollectPerson();
        this.collectTime = wdInfo.getCollectTime();
        this.showDelete = wdInfo.getShowDelete();
    }

    public WdInfoVo() {
    }
}
