package com.ruoyi.demo.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.demo.entity.Brand;
import com.ruoyi.demo.entity.Enterprise;
import com.ruoyi.demo.entity.bo.BrandSearch;
import com.ruoyi.demo.entity.vo.BrandVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface BrandMapper extends BaseMapper<Brand> {
    List<Brand> searchByIndustryCodeList(String brandId, String manageTypeCode);

    Page<BrandSearch> searchSearchByMulti(Page<BrandSearch> page, @Param("text") String text, @Param("countUp") Integer countUp, @Param("countDown") Integer countDown, @Param("coverUp") Integer coverUp, @Param("coverDown") Integer coverDown, @Param(Constants.WRAPPER) QueryWrapper<Enterprise> queryWrapper);

    //管理中心：品牌回收站
    Page<Brand> list(Page<Brand> page,@Param("brand") BrandVo brandVo);

    void recoverBrand(String brandId);

    // 按年统计品牌数量
    Integer selectCountByYear(@Param("year") String year, @Param("industryCodes") List<String> industryCodes);
}
