package com.ruoyi.demo.service.impl;


import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.BuildWd;
import com.ruoyi.demo.entity.StoreWd;
import com.ruoyi.demo.entity.WdInfo;
import com.ruoyi.demo.entity.vo.BuildwdVo;
import com.ruoyi.demo.mapper.BuildWdDao;
import com.ruoyi.demo.mapper.WdInfoDao;
import com.ruoyi.demo.service.BuildWdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class BuildWdServiceeImpl implements BuildWdService {
    @Autowired
    BuildWdDao buildWdDao;
    @Autowired
    WdInfoDao wdInfoDao;


    /**
     * 修改楼宇网点
     * @param buildwdVo
     */
    @Override
    public void updateBuildWd(BuildwdVo buildwdVo) {
        //1.修改网点基本信息
        UpdateWrapper<WdInfo> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("wd_id",buildwdVo.getWdId())
            .set("wd_name",buildwdVo.getWdName())
            .set("wd_img",buildwdVo.getWdImg())
            .set("addr_info",buildwdVo.getAddrInfo())
            .set("addr_code",buildwdVo.getAddrCode())
            .set("lat",buildwdVo.getLat())
            .set("lng",buildwdVo.getLng())
            .set("type_code_by",buildwdVo.getTypeCodeBy())
            .set("type_name_by",buildwdVo.getTypeNameBy())
            .set("update_time", DateUtils.getTime());
        wdInfoDao.update(null,updateWrapper);

        //2.修改楼宇信息
        UpdateWrapper<BuildWd> updateWrapper1 = new UpdateWrapper<>();
        updateWrapper1.eq("wd_id",buildwdVo.getWdId())
            .set("property_type",buildwdVo.getBuildWd().getPropertyType())
            .set("build_type",buildwdVo.getBuildWd().getBuildType())
            .set("households",buildwdVo.getBuildWd().getHouseholds())
            .set("people_count",buildwdVo.getBuildWd().getPeopleCount());
        buildWdDao.update(null,updateWrapper1);
    }
}
