package com.ruoyi.demo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.Enterprise;
import com.ruoyi.demo.entity.vo.EnterpriseVo;
import com.ruoyi.demo.mapper.EnterpriseMapper;
import com.ruoyi.demo.service.EnterpriseRecycleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class EnterpriseRecycleServiceImpl implements EnterpriseRecycleService {
    @Autowired
    EnterpriseMapper enterpriseMapper;
    @Override
    public Page<Enterprise> list(EnterpriseVo enterpriseVo) {
        Page<Enterprise> page = new Page<>(enterpriseVo.getPageNum(), enterpriseVo.getPageSize());
        Page<Enterprise> enterprisePage = enterpriseMapper.list(page, enterpriseVo);
        return enterprisePage;
    }

    @Override
    public void deleteEnterprise(String enterpriseUsci) {
        enterpriseMapper.deleteById(enterpriseUsci);
    }

    @Override
    public String addEnterprise(EnterpriseVo enterpriseVo) {
        QueryWrapper<Enterprise> queryWrapper = new QueryWrapper<>();
        queryWrapper.select("enterprise_usci")
                .eq("enterprise_usci",enterpriseVo.getEnterpriseUsci());
        Long aLong = enterpriseMapper.selectCount(queryWrapper);
        if (aLong > 0)
            return "该enterprise_usci已存在";
        Enterprise enterprise = new Enterprise(enterpriseVo);
        enterpriseMapper.insert(enterprise);
        return "添加成功";
    }

    @Override
    public void updateEnterprise(EnterpriseVo enterpriseVo) {
        UpdateWrapper<Enterprise> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("enterprise_usci",enterpriseVo.getEnterpriseUsci())
            .set("enterprise_img",enterpriseVo.getEnterpriseImg())
            .set("enterprise_name",enterpriseVo.getEnterpriseName())
            .set("enterprise_name_short",enterpriseVo.getEnterpriseNameShort())
            .set("addr_info",enterpriseVo.getAddrInfo())
            .set("addr_code",enterpriseVo.getAddrCode())
            .set("addr_code_info",enterpriseVo.getAddrCodeInfo())
            .set("enterprise_info",enterpriseVo.getEnterpriseInfo())
            .set("manage_range_info",enterpriseVo.getManageRangeInfo())
            .set("enterprise_scale",enterpriseVo.getEnterpriseScale())
            .set("registered_capital",enterpriseVo.getRegisteredCapital())
            .set("linkmen_id",enterpriseVo.getLinkmenId())
            .set("linkmen_name",enterpriseVo.getLinkmenName())
            .set("create_time",enterpriseVo.getCreateTime())
            .set("enterprise_itin",enterpriseVo.getEnterpriseItin())
            .set("business_status",enterpriseVo.getBusinessStatus())
            .set("industry_code",enterpriseVo.getIndustryCode())
            .set("enterprise_type",enterpriseVo.getEnterpriseType())
            .set("credit_score",enterpriseVo.getCreditScore())
            .set("hash",enterpriseVo.getHash())
            .set("update_time", DateUtils.getTime());

        enterpriseMapper.update(null,updateWrapper);
    }

    @Override
    public void recoverEnterprise(String enterpriseUsci) {
        enterpriseMapper.recoverEnterprise(enterpriseUsci);
    }

    @Override
    public Enterprise getEnterprise(String enterpriseUsci) {
        return enterpriseMapper.selectById(enterpriseUsci);
    }
}
