package com.ruoyi.demo.service.impl;


import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.EnterpriseWd;
import com.ruoyi.demo.entity.TrafficWd;
import com.ruoyi.demo.entity.WdInfo;
import com.ruoyi.demo.entity.vo.EnterpriseWdVo;
import com.ruoyi.demo.mapper.EnterpriseWdDao;
import com.ruoyi.demo.mapper.WdInfoDao;
import com.ruoyi.demo.service.EnterpriseWdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class EnterpriseWdServiceImpl implements EnterpriseWdService {
    @Autowired
    EnterpriseWdDao enterpriseWdDao;
    @Autowired
    WdInfoDao wdInfoDao;


    /**
     * 修改企业网点
     * @param enterpriseWdVo
     */
    @Override
    public void updateEnterpriseWd(EnterpriseWdVo enterpriseWdVo) {
        //1.修改网点基本信息
        UpdateWrapper<WdInfo> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("wd_id",enterpriseWdVo.getWdId())
            .set("wd_img",enterpriseWdVo.getWdImg())
            .set("wd_name",enterpriseWdVo.getWdName())
            .set("addr_info",enterpriseWdVo.getAddrInfo())
            .set("addr_code",enterpriseWdVo.getAddrCode())
            .set("lat",enterpriseWdVo.getLat())
            .set("lng",enterpriseWdVo.getLng())
            .set("type_code_by",enterpriseWdVo.getTypeCodeBy())
            .set("type_name_by",enterpriseWdVo.getTypeNameBy())
            .set("update_time", DateUtils.getTime());
        wdInfoDao.update(null,updateWrapper);


        //2.修改交通设施信息
        UpdateWrapper<EnterpriseWd> updateWrapper1 = new UpdateWrapper<>();
        updateWrapper1.eq("wd_id",enterpriseWdVo.getWdId())
            .set("enterprise_usci",enterpriseWdVo.getEnterpriseWd().getEnterpriseUsci());
        enterpriseWdDao.update(null,updateWrapper1);
    }
}
