package com.ruoyi.demo.service.impl;

;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.HouseWd;
import com.ruoyi.demo.entity.StoreWd;
import com.ruoyi.demo.entity.WdInfo;
import com.ruoyi.demo.entity.vo.HouseWdVo;
import com.ruoyi.demo.mapper.HouseWdDao;
import com.ruoyi.demo.mapper.WdInfoDao;
import com.ruoyi.demo.service.HouseWdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class HouseWdServiceImpl implements HouseWdService {
    @Autowired
    HouseWdDao houseWdDao;

    @Autowired
    WdInfoDao wdInfoDao;


    /**
     * 修改小区网点
     * @param houseWdVo
     */
    @Override
    public void updateHouseWd(HouseWdVo houseWdVo) {
        //1.修改网点基本信息
        UpdateWrapper<WdInfo> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("wd_id",houseWdVo.getWdId())
            .set("wd_name",houseWdVo.getWdName())
            .set("wd_img",houseWdVo.getWdImg())
            .set("addr_info",houseWdVo.getAddrInfo())
            .set("addr_code",houseWdVo.getAddrCode())
            .set("lat",houseWdVo.getLat())
            .set("lng",houseWdVo.getLng())
            .set("type_code_by",houseWdVo.getTypeCodeBy())
            .set("type_name_by",houseWdVo.getTypeNameBy())
            .set("update_time", DateUtils.getTime());
        wdInfoDao.update(null,updateWrapper);

        //2.修改小区信息
        UpdateWrapper<HouseWd> updateWrapper1 = new UpdateWrapper<>();
        updateWrapper1.eq("wd_id",houseWdVo.getWdId())
            .set("property_type",houseWdVo.getHouseWd().getPropertyType())
            .set("households",houseWdVo.getHouseWd().getHouseholds())
            .set("people_count",houseWdVo.getHouseWd().getPeopleCount());
        houseWdDao.update(null,updateWrapper1);
    }
}
