package com.ruoyi.demo.service.impl;


import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.StoreWd;
import com.ruoyi.demo.entity.WdInfo;
import com.ruoyi.demo.entity.vo.StoreWdVo;
import com.ruoyi.demo.mapper.StoreWdDao;
import com.ruoyi.demo.mapper.WdInfoDao;
import com.ruoyi.demo.mapper.WdInfoMapper;
import com.ruoyi.demo.service.StoreWdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class StoreWdServiceImpl implements StoreWdService {
    @Autowired
    StoreWdDao storeWdDao;

    @Autowired
    WdInfoDao wdInfoDao;


    /**
     * 修改门店网点
     * @param storeWdVo
     */
    @Override
    public void updateStoreWd(StoreWdVo storeWdVo) {
        //1.修改网点基本信息
        UpdateWrapper<WdInfo> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("wd_id",storeWdVo.getWdId())
            .set("wd_img",storeWdVo.getWdImg())
            .set("wd_name",storeWdVo.getWdName())
            .set("addr_info",storeWdVo.getAddrInfo())
            .set("addr_code",storeWdVo.getAddrCode())
            .set("lat",storeWdVo.getLat())
            .set("lng",storeWdVo.getLng())
            .set("type_code_by",storeWdVo.getTypeCodeBy())
            .set("type_name_by",storeWdVo.getTypeNameBy())
            .set("update_time", DateUtils.getTime());
        wdInfoDao.update(null,updateWrapper);

        //2.修改门店信息
        UpdateWrapper<StoreWd> updateWrapper1 = new UpdateWrapper<>();
        updateWrapper1.eq("wd_id",storeWdVo.getWdId())
            .set("brand_id",storeWdVo.getStoreWd().getBrandId())
            .set("brand_name",storeWdVo.getStoreWd().getBrandName())
            .set("per_capita_consumption",storeWdVo.getStoreWd().getPerCapitaConsumption())
            .set("manage_type_code",storeWdVo.getStoreWd().getManageTypeCode())
            .set("industry_code",storeWdVo.getStoreWd().getIndustryCode())
            .set("comment_count",storeWdVo.getStoreWd().getCommentCount())
            .set("score",storeWdVo.getStoreWd().getScore())
            .set("buy_info",storeWdVo.getStoreWd().getBuyInfo())
            .set("index_score",storeWdVo.getStoreWd().getIndexScore())
            .set("business_status",storeWdVo.getStoreWd().getBusinessStatus())
            .set("business_time",storeWdVo.getStoreWd().getBusinessTime())
            .set("telephone",storeWdVo.getStoreWd().getTelephone())
            .set("contact",storeWdVo.getStoreWd().getContact())
            .set("channel_type",storeWdVo.getStoreWd().getChannelType())
            .set("opentime",storeWdVo.getStoreWd().getOpentime())
            .set("closetime",storeWdVo.getStoreWd().getClosetime());
        storeWdDao.update(null,updateWrapper1);
    }
}
