package com.ruoyi.demo.service.impl;


import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.BuildWd;
import com.ruoyi.demo.entity.TrafficWd;
import com.ruoyi.demo.entity.WdInfo;
import com.ruoyi.demo.entity.vo.TrafficWdVo;
import com.ruoyi.demo.mapper.TrafficWdDao;
import com.ruoyi.demo.mapper.WdInfoDao;
import com.ruoyi.demo.service.TrafficWdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class TrafficWdServiceImpl implements TrafficWdService {
    @Autowired
    TrafficWdDao trafficWdDao;

    @Autowired
    WdInfoDao wdInfoDao;


    /**
     * 修改交通设施网点
     * @param trafficWd
     */
    @Override
    public void updateTrafficWd(TrafficWdVo trafficWd) {
        //1.修改网点基本信息
        UpdateWrapper<WdInfo> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("wd_id",trafficWd.getWdId())
            .set("wd_img",trafficWd.getWdImg())
            .set("wd_name",trafficWd.getWdName())
            .set("addr_info",trafficWd.getAddrInfo())
            .set("addr_code",trafficWd.getAddrCode())
            .set("lat",trafficWd.getLat())
            .set("lng",trafficWd.getLng())
            .set("type_code_by",trafficWd.getTypeCodeBy())
            .set("type_name_by",trafficWd.getTypeNameBy())
            .set("update_time", DateUtils.getTime());
        wdInfoDao.update(null,updateWrapper);

        //2.修改交通设施信息
        UpdateWrapper<TrafficWd> updateWrapper1 = new UpdateWrapper<>();
        updateWrapper1.eq("wd_id",trafficWd.getWdId())
            .set("cars",trafficWd.getTrafficWd().getCars());
        trafficWdDao.update(null,updateWrapper1);
    }
}
