package com.ruoyi.demo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.demo.entity.StoreWd;
import com.ruoyi.demo.entity.WdInfo;
import com.ruoyi.demo.entity.vo.StoreWdVo;
import com.ruoyi.demo.entity.vo.WdInfoVo;
import com.ruoyi.demo.mapper.StoreWdDao;
import com.ruoyi.demo.mapper.WdInfoMapper;
import com.ruoyi.demo.service.WdRecycleService;
import com.ruoyi.demo.utils.InitMapUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.stream.Collectors;

@Service
@Transactional
public class WdRecycleServiceImpl implements WdRecycleService {

    @Autowired
    WdInfoMapper wdInfoMapper;

    @Autowired
    InitMapUtil initMapUtil;

    /**
     * 获取网点列表
     * @param wdInfoVo 网点信息接受体
     * @return
     */
    @Override
    public HashMap<String, Object> list(WdInfoVo wdInfoVo) {
        //1.查询符合条件的数据
        Page<WdInfo> page = new Page<>(wdInfoVo.getPageNum(), wdInfoVo.getPageSize());
        Page<WdInfo> page1 = wdInfoMapper.list(page, wdInfoVo);

        //2.预处理
//        List<WdInfoVo> collect = page1.getRecords().stream().map(wdInfo -> {
//            if (wdInfo.getTypeNameBy() != null) {
//                String[] split = wdInfo.getTypeNameBy().split(":");
//                if (split.length == 3)
//                    wdInfo.setTypeNameBy(split[2]);
//                else if (split.length == 2)
//                    wdInfo.setTypeNameBy(split[1]);
//                else
//                    wdInfo.setAddrInfo(wdInfo.getTypeNameBy().replace(":", ""));
//            }
//
//            WdInfoVo wdInfoVo1 = new WdInfoVo(wdInfo);
//            //wdInfoVo1.setAddrCodeInfo(initMapUtil.getInitAddrCodeMap(wdInfoVo1.getAddrCode()));
//            return wdInfoVo1;
//        }).collect(Collectors.toList());

        //3.返回结果
        HashMap<String, Object> result = new HashMap<>();
        result.put("data", page1.getRecords());
        page1.setRecords(null);
        result.put("page", page1);
        return result;
    }

    /**
     * 移除网点
     * @param wdId 网点Id
     */
    @Override
    public void deleteWd(String wdId) {
        wdInfoMapper.deleteById(wdId);
    }

    /**
     * 恢复网点
     * @param wdId 网点Id
     */
    @Override
    public void recoverWd(String wdId) {
        wdInfoMapper.recoverWd(wdId);
    }
}
