package com.ruoyi.demo.utils.statistics;

import cn.hutool.core.date.DateUtil;
import com.ruoyi.demo.entity.AttentionPoolStatistics;
import com.ruoyi.demo.mapper.AttentionPoolDao;
import com.ruoyi.demo.mapper.AttentionPoolStatisticsDao;
import com.ruoyi.demo.mapper.BusinessOpportunitiesDao;
import com.ruoyi.demo.mapper.FollowUpDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.UUID;

@Component
public class AttentionPoolStat {
    @Autowired
    AttentionPoolDao poolDao;
    @Autowired
    BusinessOpportunitiesDao opportunitiesDao;
    @Autowired
    FollowUpDao followUpDao;
    @Autowired
    AttentionPoolStatisticsDao statisticsDao;

    public void insert() {
        List<String> ins = poolDao.selectAllUser();
        for (String userId : ins) {
            AttentionPoolStatistics statistics = new AttentionPoolStatistics();
            statistics.setStatId(UUID.randomUUID().toString().replace("-", ""));
            statistics.setAttentionCount(poolDao.selectCount(userId));
            statistics.setClueCount(opportunitiesDao.selectCount(userId));
            statistics.setOnlineCount(followUpDao.selectCountByWay(userId, "线上电话"));
            statistics.setOfflineCount(followUpDao.selectCountByWay(userId, "实地考察"));
            statistics.setUserId(userId);
            statistics.setStatTime(DateUtil.date());
            statisticsDao.insert(statistics);
        }
    }
}
