import request from '@/utils/request'

//恢复
export function recoverBrand(brandId){
  return request({
    url: '/recycle/brand/recoverBrand',
    method: 'put',
    data:{brandId:brandId}
  })
}

//移除
export function deleteBrand(brandId) {
  return request({
    url: `/recycle/brand/deleteBrand/${brandId}`,
    method: 'delete',
  })
}

// 查询品牌列表
export function listBrand(query) {
  return request({
    url: '/recycle/brand/list',
    method: 'get',
    params: query
  })
}

// 查询品牌详细
export function getBrand(brandId) {
  return request({
    url: '/core/brand/' + brandId,
    method: 'get'
  })
}

// 新增品牌
export function addBrand(data) {
  return request({
    url: '/core/brand',
    method: 'post',
    data: data
  })
}

// 修改品牌
export function updateBrand(data) {
  return request({
    url: '/core/brand',
    method: 'put',
    data: data
  })
}

// 删除品牌
export function delBrand(brandId) {
  return request({
    url: '/core/brand/' + brandId,
    method: 'delete'
  })
}
