import request from '@/utils/request'
//恢复网点
export function recoverWd(wdId){
  return request({
    url: '/recycle/wd/recoverWd',
    method: 'put',
    data: {wdId:wdId}
  })
}


//移除网点
export function deleteWd(wdId){
  return request({
    url: `/recycle/wd/deleteWd/${wdId}`,
    method: 'delete'
  })
}

//查看公司网点明细
export function getEnterpriseWd(wdId){
  return request({
    url: '/bailianAi/recycle/wd/enterpriseWdInfo',
    method: 'get',
    params: {wdId:wdId}
  })
}

//查看交通设施网点明细
export function getTrafficWd(wdId){
  return request({
    url: '/recycle/wd/trafficWdInfo',
    method: 'get',
    params: {wdId:wdId}
  })
}

//查看楼宇网点明细
export function getBuildWd(wdId){
  return request({
    url: '/recycle/wd/buildWdInfo',
    method: 'get',
    params: {wdId:wdId}
  })
}

//查看小区网点明细
export function getHouseWd(wdId){
  return request({
    url: '/recycle/wd/houseWdInfo',
    method: 'get',
    params: {wdId:wdId}
  })
}

//查看门店网点明细
export function getStoreWd(wdId){
  return request({
    url: '/recycle/wd/storeWdInfo',
    method: 'get',
    params: {wdId:wdId}
  })
}

// 获取网点标签
export function getAddrCode() {
  return request({
    url: '/getAddrCategory',
    method: 'get',
  })
}

// 获取网点标签
export function getTag() {
  return request({
    url: '/common/tag',
    method: 'get',
  })
}

// 查询网点回收站列表
export function listWdInfo(query) {
  return request({
    url: '/recycle/wd/list',
    method: 'get',
    params: query
  })
}

// 查询网点回收站详细
export function getWdInfo(wdId) {
  return request({
    url: '/wdInfo/wdInfo/' + wdId,
    method: 'get'
  })
}

// 新增网点回收站
export function addWdInfo(data) {
  return request({
    url: '/wdInfo/wdInfo',
    method: 'post',
    data: data
  })
}

// 修改网点回收站
export function updateWdInfo(data) {
  return request({
    url: '/wdInfo/wdInfo',
    method: 'put',
    data: data
  })
}

// 删除网点回收站
export function delWdInfo(wdId) {
  return request({
    url: '/wdInfo/wdInfo/' + wdId,
    method: 'delete'
  })
}
